import { Machine, State, On, Do, Goto, Spawn, Unspawn } from '../index';

const beginTimer = ()=>{};

type S = 'green' | 'yellow' | 'red';
type E = ['entry',null] | ['timer-finished',null];

const machine = 
  Machine<S,E>(
    State('green',
      On('entry', 
        Do(beginTimer)
      ),
      On('timer-finished',
        Goto('yellow')
      )
    ),
    State('yellow',
      On('entry', 
        Do(beginTimer)
      ),
      On('timer-finished',
        Goto('red')
      )
    ),
    State('red',
      On('entry', 
        Do(beginTimer)
      ),
      On('timer-finished',
        Goto('green')
      )
    ),
  );